--[[
    Author: Alternator (Massiner of Nathrezim)
    Date:	2020
    
    Desc:	Custom Action registry - addons that use this engine need to register any custom actions that they want supported on these buttons
]]

local AddonName, AddonTable = ...;
local Engine = AddonTable.ButtonEngine;
local CustomActionRegistry = Engine.CustomActionRegistry;

local CustomActions = {};


--[[------------------------------------------------
    RegisterCustomAction
--------------------------------------------------]]
function CustomActionRegistry.RegisterCustomAction(Name, UpdateFunctions)

    CustomActions[Name] = {};
    CustomActions[Name].GetAction	= UpdateFunctions.GetAction;
    CustomActions[Name].GetIcon		= UpdateFunctions.GetIcon;
    CustomActions[Name].IsChecked	= UpdateFunctions.IsChecked;
    CustomActions[Name].IsUsable	= UpdateFunctions.IsUsable;
    CustomActions[Name].GetCooldown = UpdateFunctions.GetCooldown;
    CustomActions[Name].IsEquipped	= UpdateFunctions.IsEquipped;
    CustomActions[Name].GetText		= UpdateFunctions.GetText;
    CustomActions[Name].IsGlowing	= UpdateFunctions.IsGlowing;
    CustomActions[Name].UpdateTooltip	= UpdateFunctions.UpdateTooltip;
    CustomActions[Name].IsFlashing	= UpdateFunctions.IsFlashing;
    CustomActions[Name].IsInRange	= UpdateFunctions.IsInRange;


end


--[[------------------------------------------------
    RegisterCustomAction
--------------------------------------------------]]
function CustomActionRegistry.GetCustomAction(Name)
    return CustomActions[Name];
end



