--[[
    Author: Alternator (Massiner of Nathrezim)
    Date:	2014

]]

local AddonName, AddonTable = ...;
local Engine = AddonTable.ButtonEngine;
local ScriptsBattlePetFavorite = Engine.ScriptsBattlePetFavorite;

local C = Engine.Constants;
local Core = Engine.Core;
local Util = Engine.Util;


--[[------------------------------------------------
    UpdateAction
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateAction(BFButton)

end

function ScriptsBattlePetFavorite.UpdateAttributes(BFButton)
    BFButton.ABW:SetAttribute("type", "macro");
    BFButton.ABW:SetAttribute("macrotext", format("/summonpet %s", C.SUMMON_RANDOM_FAVORITE_PET_GUID));
end
function ScriptsBattlePetFavorite.UpdateSecureCursor(BFButton)
    BFButton.ABW:SetAttribute("CursorKind", nil);
    BFButton.ABW:SetAttribute("CursorTarget", nil);
end
function ScriptsBattlePetFavorite.UpdateActionTable(BFButton)
    local Action = BFButton.Action;
    Util.ClearTable(Action);
    Action.Type = "favoritebattlepet";
end

--[[------------------------------------------------
    Full Update
--------------------------------------------------]]
function ScriptsBattlePetFavorite.FullUpdate(BFButton)
    BFButton.ABWIcon:SetTexture(BFButton.IconTexture);	
    BFButton:UpdateUsable();
    
    if (GetMouseFocus() == BFButton.ABW) then
        BFButton.ABW:UpdateTooltip();
    end
end


--[[------------------------------------------------
    Icon
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateIcon(BFButton)

end


--[[------------------------------------------------
    Checked
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateChecked(BFButton)

end


--[[------------------------------------------------
    Usable
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateUsable(BFButton)
    Core.UpdateButtonUsable(BFButton, C_PetJournal.PetIsSummonable(C.SUMMON_RANDOM_FAVORITE_PET_GUID));
end


--[[------------------------------------------------
    Cooldown
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateCooldown(BFButton)
    CooldownFrame_Set(BFButton.ABWCooldown, C_PetJournal.GetSummonBattlePetCooldown());
end


--[[------------------------------------------------
    Tooltip
--------------------------------------------------]]
function ScriptsBattlePetFavorite.UpdateTooltip(ABW)
    GameTooltip_SetDefaultAnchor(GameTooltip, ABW);

    -- This next bit more or less lifted from the Pet Journal implementation
    local numPets, numOwned = C_PetJournal.GetNumPets();
    if ( numOwned > 0 and not C_PetBattles.IsInBattle()  ) then
        GameTooltip:SetCompanionPet(C.SUMMON_RANDOM_FAVORITE_PET_GUID);
    else
        GameTooltip:SetSpellByID(C.SUMMON_RANDOM_FAVORITE_PET_SPELL);
    end
end


--[[------------------------------------------------
    Cursor
--------------------------------------------------]]
function ScriptsBattlePetFavorite.GetCursor(BFButton)
    return "battlepet", C.SUMMON_RANDOM_FAVORITE_PET_GUID, nil, nil;
end

