--[[
    Author: Alternator (Massiner of Nathrezim)
    Date:	2014

]]

local AddonName, AddonTable = ...;
local Engine = AddonTable.ButtonEngine;
local ScriptsMountFavorite = Engine.ScriptsMountFavorite;

local C = Engine.Constants;
local Core = Engine.Core;
local Util = Engine.Util;


--[[------------------------------------------------
    UpdateAction
--------------------------------------------------]]
function ScriptsMountFavorite.UpdateAction(BFButton)

end

function ScriptsMountFavorite.UpdateAttributes(BFButton)
    BFButton.ABW:SetAttribute("type", "macro");
    BFButton.ABW:SetAttribute("macrotext", "/script C_MountJournal.SummonByID(0);");
end
function ScriptsMountFavorite.UpdateSecureCursor(BFButton)
    BFButton.ABW:SetAttribute("CursorKind", nil);
    BFButton.ABW:SetAttribute("CursorTarget", nil);
end
function ScriptsMountFavorite.UpdateActionTable(BFButton)
    local Action = BFButton.Action;
    Util.ClearTable(Action);
    Action.Type = "favoritemount";
    Action.MountID = BFButton.MountID;
    Action.MountSpellID = BFButton.MountSpellID;
    Action.MountName = BFButton.MountName;
end

--[[------------------------------------------------
    Full Update
--------------------------------------------------]]
function ScriptsMountFavorite.FullUpdate(BFButton)
    BFButton.IconTexture = GetSpellTexture(BFButton.MountSpellID);
    BFButton.ABWIcon:SetTexture(BFButton.IconTexture);	
    BFButton:UpdateIcon();
    BFButton:UpdateChecked();
    BFButton:UpdateUsable();
    
    if (GetMouseFocus() == BFButton.ABW) then
        BFButton.ABW:UpdateTooltip();
    end
end


--[[------------------------------------------------
    Icon
--------------------------------------------------]]
function ScriptsMountFavorite.UpdateIcon(BFButton)

end


--[[------------------------------------------------
    Checked
    Notes:
        * WoW v7 (13-Aug-2016)
            * summoning any mount should check summon favorite
            * It's not possible to simply test if the player is in
            process of summoning a mount (not cheaply anyway)
--------------------------------------------------]]
function ScriptsMountFavorite.UpdateChecked(BFButton)
    if (IsMounted()) then
        BFButton.ABW:SetChecked(true);
    else
        local _, _, _, _, _, _, _, _, SpellID = UnitCastingInfo("player");
        SpellID = SpellID or 0;
        if (C_MountJournal.GetMountFromSpell(SpellID)) then
            BFButton.ABW:SetChecked(true);
        else
            BFButton.ABW:SetChecked(false);
        end
    end
end


--[[------------------------------------------------
    Usable
        This doesn't really work
        The correct implementation is to scan each favorite
        and detect if any are usable... since that could be expensive
        for a low value payout I'll just leave it (I doubt the spell api call
        ever correctly identifies it is unusable)
--------------------------------------------------]]
function ScriptsMountFavorite.UpdateUsable(BFButton)
    Core.UpdateButtonUsable(BFButton, IsUsableSpell(BFButton.MountSpellID));
end


--[[------------------------------------------------
    Tooltip
--------------------------------------------------]]
function ScriptsMountFavorite.UpdateTooltip(ABW)
    GameTooltip_SetDefaultAnchor(GameTooltip, ABW);
    GameTooltip:SetMountBySpellID(ABW.BFButton.MountSpellID);
end


--[[------------------------------------------------
    Cursor
--------------------------------------------------]]
function ScriptsMountFavorite.GetCursor(BFButton)
    return "mount", BFButton.MountID, nil, nil;
end

